{% case transaction.params.ext-connection %}
{%   when "##PASSKEY_DB_CONNECTION##" %}
{%     assign auth_mode = "passkey" %}
{%   when "##PASSWORD_DB_CONNECTION##" %}
{%     assign auth_mode = "password" %}
{%   else %}
{%     if prompt.name == "mfa-otp" %}
{%       assign auth_mode = "mfa" %}
{%     else %}
{%       assign auth_mode = "unsupported" %}
{%     endif %}
{% endcase %}
<!-- 
auth_mode:   {{ auth_mode }}
prompt.name: {{ prompt.name }}
-->

<!DOCTYPE html>
<html lang="{{locale}}">
  <head>
    {%- auth0:head -%}

    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.1.3/dist/css/bootstrap.min.css"
      integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO"
      crossorigin="anonymous"
    />
    <script
      src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
      integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/popper.js@1.14.3/dist/umd/popper.min.js"
      integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@4.1.3/dist/js/bootstrap.min.js"
      integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy"
      crossorigin="anonymous"
    ></script>

    <script src="##HYPR_BASE_URL##/static/fixed/utils.js"></script>
    <script src="##RP_APP_BASE_URL##/scripts/hyprfido2sdk.js"></script>
    <script src="##RP_APP_BASE_URL##/scripts/core.js"></script>
    <script src="##RP_APP_BASE_URL##/scripts/fido-util.js"></script>
    <script src="##RP_APP_BASE_URL##/scripts/management.js"></script>

    <style>
      body {
        background-image: url("##PAGE_BACKGROUND_IMAGE_URL##");
        background-size: cover;
        background-position: center;
        background-repeat: no-repeat;
      }
    </style>
    <title>{{ prompt.screen.texts.pageTitle }}</title>
  </head>

  <!-- login widget -->
  <body class="_widget-auto-layout">
    <div id="main-container" style="display: none">
      {%- auth0:widget -%}
    </div>
  </body>

{% if auth_mode == "passkey" and prompt.name == "login-password" %}
  <!-- UAF modal -->
  <div
    class="modal fade"
    id="uaf_model"
    tabindex="-1"
    role="dialog"
    aria-labelledby="uaf_model_title"
    aria-hidden="true"
  >
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="uaf_model_title">
            Sign in with a ##UAF_APP_NAME## device
          </h5>
          <button
            type="button"
            class="close"
            data-dismiss="modal"
            aria-label="Close"
          >
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body text-center">
          <div id="qr-code-section" style="display: none;">
            <p>
              Scan the QR code to sign in with the ##UAF_APP_NAME## device
            </p>
            <img
              id="qr-code-image"
              alt="QR code"
              src=""
              style="height: 200px; width: 200px"
            />
          </div>
          <div id="pending-section" style="display: none;">
            <p>Waiting for your sign-in to complete...</p>
          </div>
          <div id="timeout-section" style="display: none;">
            <p>The user cancelled in the app or something took too long.</p>
            <p>Close this dialog and try again.</p>
          </div>
        </div>
        <div class="modal-footer">
          <button
            type="button"
            class="btn btn-secondary"
            data-dismiss="modal"
          >
            Cancel
          </button>
        </div>
      </div>
    </div>
  </div>
{% endif %}

  <script>
    const RP_APP_BASE_URL = "##RP_APP_BASE_URL##";

    window.addEventListener("load", async () => {
{% if auth_mode == "passkey" %}
      // variables
      const defaultOptions = {
        rpBaseUrl: RP_APP_BASE_URL,
      };
  {% if prompt.name == "login-id" or prompt.name == "login-password" %}
      const defaultAssertionOptions = {
        ...defaultOptions,
        userVerification: "required",
        authenticatorAttachment: "cross-platform",
      };
  {% endif %}
  {% if prompt.name == "signup-password" %}
      const defaultAttestationOptions = {
        ...defaultOptions,
      };
  {% endif %}
  {% if prompt.name == "login-password" %}
      let autofillToken;
      let uafAbortController;
  {% endif %}
{% endif %}

      // UI elements

{% if prompt.name == "login-id" or prompt.name == "login-password" %}
      const usernameField = document.querySelector("input[name='username']");
{% endif %}      
{% if prompt.name == "signup-id" or prompt.name == "signup-password" %}
      const usernameField = document.querySelector("input[name='email']");
{% endif %}

{% if auth_mode == "password" or auth_mode == "passkey" %}
      const loginForm = usernameField.closest("form");
      const alternativeActionsContainer = document.querySelector("._alternate-action");
{% endif %}
  
{% if prompt.name == "login-password" or prompt.name == "signup-password" %}
      const passwordField = document.querySelector("input[name='password']");
      const passwordFieldWrapper = passwordField.closest(".input-wrapper");
{% endif %}

{% if prompt.name == "login-id" or prompt.name == "login-password" or prompt.name == "signup-id" %}
      const submitButton = document.querySelector("._button-{{ prompt.name }}");
{% endif %}
{% if prompt.name == "signup-password" %}
      const submitButton = document.querySelector("button[type='submit']");
{% endif %}
{% if auth_mode == "passkey" %}
      const submitButtonContainer = submitButton.parentElement;
{% endif %}
{% if auth_mode == "passkey" and prompt.name == "login-password" %}
      const uafQrCodeSection = document.getElementById("qr-code-section");
      const uafQrCodeImage = document.getElementById("qr-code-image");
      const uafPendingSection = document.getElementById("pending-section");
      const uafTimeoutSection = document.getElementById("timeout-section");
{% endif %}

      // Helpers

      function showElement(element) {
        element.style.display = "block";
      }

      function hideElement(element) {
        element.style.display = "none";
      }

      function enableElement(element) {
        element.disabled = false;
      }

      function disableElement(element) {
        element.disabled = true;
      }

      function displayMainContent() {
        const mainContainer = document.getElementById("main-container");
        showElement(mainContainer);

        const fieldToFocus = document.querySelector("[autofocus]");
        if (fieldToFocus) {
          fieldToFocus.focus();
        }
      }

      function getSwitchUrl(connection) {
        let url = "{{application.metadata.connection_switch_uri}}?" +
          `&connection=${encodeURIComponent(connection)}`;
{% if auth_mode != "unsupported" or prompt.name == "login-password" %}
        if (usernameField.value) {
          url += `&login_hint=${encodeURIComponent(usernameField.value)}`;
        }
{% endif %}
{% if prompt.name == "signup-id" or prompt.name == "signup-password" %}
        url += "&screen_hint=signup";
{% endif %}

        return url;
      }

      function switchConnection(connection) {
        const url = getSwitchUrl(connection);

        window.location.href = url;
      }

      function showPasskeySignIn() {
        switchConnection("##PASSKEY_DB_CONNECTION##");
      }

      function showPasswordSignIn() {
        switchConnection("##PASSWORD_DB_CONNECTION##");
      }

      function insertAlternativeAction(message, action, linkText) {
        const firstAction = alternativeActionsContainer.querySelector("p");
        if (!firstAction) {
          throw new Error("No existing action to clone");
        }

        const newAction = firstAction.cloneNode(true);
        const textNode = [...newAction.childNodes]
          .find(n => n.nodeType === Node.TEXT_NODE);
        textNode.nodeValue = message;
        const link = newAction.querySelector("a");

        if (action instanceof Function) {
          link.href = "#";
          link.innerText = linkText;
          link.addEventListener("click", action);
        } else {
          link.href = action;
          link.innerText = linkText;
        }

        firstAction.before(newAction);
      }

{% if auth_mode == "passkey" %}

      function displayError(err) {
        const message = err.policy || err.description || err.message || err;

  {% if prompt.name == "login-password" or prompt.name == "signup-password" %}

        // create error message content
        const errorMessageContainer = document.createElement("span");
        errorMessageContainer.setAttribute("class", "ulp-input-error-message");
        const errorIcon = document.createElement("span");
        errorIcon.setAttribute("class", "ulp-input-error-icon");
        errorIcon.setAttribute("role", "img");
        errorIcon.setAttribute("aria-label", "Error");
        errorMessageContainer.appendChild(errorIcon);
        const errorMessageText = document.createTextNode(message);
        errorMessageContainer.appendChild(errorMessageText);
        loginForm.appendChild(errorMessageContainer);

        // decorate username field
        const usernameFieldContainer = usernameField.parentElement;
        usernameFieldContainer.style.borderColor = "var(--error-color)";
        const usernameTextSpan = document.querySelector(".ulp-authenticator-selector-text"); 
        usernameTextSpan.style.color = "var(--error-color)";

  {% else %}

        // change description text
        const headerContainer = document.querySelector("header");
        const descriptionContainer = [...headerContainer.childNodes]
          .findLast((e) => e.tagName === "DIV");
        const descriptionParagraph = descriptionContainer.querySelector("p");
        descriptionParagraph.innerText = message;
        descriptionParagraph.style.color = "var(--error-color)";

  {% endif %}
      }

  {% if prompt.name == "login-id" or prompt.name == "login-password" %}
      async function passkeySignIn() {
        const username = usernameField.value;

        let result;
        let errorMessage = "";
        try {
          result = await authenticatePasskey({
            ...defaultAssertionOptions,
            username,
          });
        } catch (err) {
          if (err.name === "NotAllowedError") {
            errorMessage = "There was an issue signing in with your passkey";
          } else {
            return displayError(err);
          }          
        }

        if (!errorMessage && !result) {
          errorMessage = "We couldn't find a passkey";
        }

        if (errorMessage) {
          showElement(alternativeActionsContainer);

    {% if prompt.name == "login-password" %}
          try {
            devicesAvailable = await getFidoAuthenticationMethods({
              ...defaultAssertionOptions,
              username,
            });
          } catch (err) {
            return displayError(err);
          }
          if (devicesAvailable.uaf) {
            // offer UAF auth
            insertAlternativeAction(
              "Or",
              uafSignIn,
              "Try with a ##UAF_APP_NAME## device"
            );
          }
    {% endif %}

          // offer password auth
          insertAlternativeAction(
            "Having issues?",
            getSwitchUrl("##PASSWORD_DB_CONNECTION##"),
            "Try with a password"
          );

          return displayError(errorMessage);
        }

        passwordField.value = result.token;
        loginForm.submit();
      }
  {% endif %}

  {% if prompt.name == "login-password" %}
      async function uafSignIn() {
        uafAbortController = new AbortController();

        const username = usernameField.value;

        let result;
        try {
          result = await authenticateUaf({
            ...defaultOptions,
            username,
            displayQrCode: (qrCodeDataUrl) => {
              uafQrCodeImage.src = qrCodeDataUrl;
              $("#uaf_model").modal("show");
              showElement(uafQrCodeSection);
              hideElement(uafPendingSection);
              hideElement(uafTimeoutSection);
            },
            displayPendingMessage: () => {
              hideElement(uafQrCodeSection);
              showElement(uafPendingSection);
              hideElement(uafTimeoutSection);
            },
            displayTimeoutMessage: () => {
              hideElement(uafQrCodeSection);
              hideElement(uafPendingSection);
              showElement(uafTimeoutSection);
            },
            abortSignal: uafAbortController.signal,
          });
        } catch (err) {
          return displayError(err);
        }

        if (result) {
          passwordField.value = result.token;
          loginForm.submit();
        }
      }
  {% endif %}

  {% if prompt.name == "signup-password" %}
      async function passkeySignUp() {
        const username = usernameField.value;

        let result;
        let errorMessage = "";
        try {
          result = await registerPasskey({
            ...defaultAttestationOptions,
            username,
            displayName: username
          });
        } catch (err) {
          if (err.name === "NotAllowedError") {
            // offer password registration
            showElement(alternativeActionsContainer);
            insertAlternativeAction(
              "Having issues?",
              getSwitchUrl("##PASSWORD_DB_CONNECTION##"),
              "Try with a password"
            );

            return displayError("There was an issue enrolling your passkey");
          } else {
            return displayError(err);
          }
        }

        passwordField.value = result.token;
        loginForm.submit();        
      }
  {% endif %}
{% endif %}

{% if auth_mode == "passkey" %}
      // Event handlers
  {% if prompt.name == "login-id" %}
      submitButton.addEventListener("click", async (e) => {
        e.preventDefault();

        const username = usernameField.value;
        let devicesAvailable;
        try {
          devicesAvailable = await getFidoAuthenticationMethods({
            ...defaultAssertionOptions,
            username,
          });
        } catch (err) {
          return displayError(err);
        }

        if (!devicesAvailable.fido2 && !devicesAvailable.uaf) {
          // no devices - prompt for password instead
          showPasswordSignIn();
        } else {
          loginForm.submit();
        }
      });
  {% endif %}

  {% if prompt.name == "login-password" %}
      $("#uaf_model").on("hide.bs.modal", () => {
        // offer password auth
        showElement(alternativeActionsContainer);
        insertAlternativeAction(
          "Having issues?",
          getSwitchUrl("##PASSWORD_DB_CONNECTION##"),
          "Try with a password"
        );
        // stop uaf polling
        uafAbortController.abort();
      });
  {% endif %}
{% endif %}

      // Initial UI state

{% case auth_mode %}
  {% when "unsupported" %}
      showPasskeySignIn();

  {% when "password" %}
      displayMainContent();

    {% if prompt.name == "login-id" or prompt.name == "signup-id" %}
      usernameField.focus();
    {% endif %}

    {% if prompt.name == "login-password" %}
      passwordField.focus();
      insertAlternativeAction(
        "Got a Passkey?",
        getSwitchUrl("##PASSKEY_DB_CONNECTION##"),
        "Use that instead"
      );
    {% endif %}

    {% if prompt.name == "signup-password" %}
      passwordField.focus();
      insertAlternativeAction(
        "Tired of passwords?",
        getSwitchUrl("##PASSKEY_DB_CONNECTION##"),
        "Use a Passkey instead"
      );
    {% endif %}

  {% when "passkey" %}
      displayMainContent();

    {% if prompt.name == "login-id" and "##PASSKEY_AUTOFILL_ENABLED##" == "true" %}
      // Attempt passkey autofill
      if (await isPasskeyAutofillSupported()) {
        usernameField.setAttribute("autocomplete", "username webauthn");

        let result;
        try {
          result = await authenticatePasskey({
            ...defaultAssertionOptions,
            username: "",
            attemptAutofill: true,
          });
        } catch (err) {
          return console.error("Error with passkey autofill:", err);
        }
        
        usernameField.value = result.username;
        await storeToken(defaultOptions, result.token);
        loginForm.submit();
      }
    {% endif %}

    {% if prompt.name == "login-id" or prompt.name == "signup-id" %}
      usernameField.focus();
    {% endif %}

    {% if prompt.name == "login-password" or prompt.name == "signup-password" %}
      hideElement(passwordFieldWrapper);
      hideElement(submitButtonContainer);
      hideElement(alternativeActionsContainer);
    {% endif %}

    {% if prompt.name == "login-password" and "##PASSKEY_AUTOFILL_ENABLED##" == "true" %}
      if (await isPasskeyAutofillSupported()) {
        // check to see if we've stored a token from autofill in login-id
        autofillToken = await recallToken(defaultOptions);
        if (autofillToken) {
          passwordField.value = autofillToken;
          loginForm.submit();
        }
      }
    {% endif %}

    {% if prompt.name == "login-password" %}
      let devicesAvailable;
      try {
        devicesAvailable = await getFidoAuthenticationMethods({
          ...defaultAssertionOptions,
          username: usernameField.value,
        });
      } catch (err) {
        return displayError(err);
      }
      if (!devicesAvailable.fido2 && devicesAvailable.uaf) {
        // automatically attempt UAF sign in if UAF devices exist but no FIDO2
        uafSignIn();
      } else if (!autofillToken) {
        // perform passkey sign in flow if not autofill
        passkeySignIn();
      }
    {% endif %}

    {% if prompt.name == "signup-password" %}
      passkeySignUp();
    {% endif %}
  {% when "mfa" %}
      displayMainContent();

{% endcase %}
    });
  </script>
</html>
